local RANB = LibStub("AceAddon-3.0"):NewAddon("Rise Above Need Boss", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Rise Above Need Boss")
local AceGUI = LibStub("AceGUI-3.0")
local isShow = false
local g11i, g21i, g12i, g22i
local RAIDERS = {}

function RANB:OnInitialize()
	RANB:Print(L["Loaded. Type '/nb' to ask who need the next boss."])
	-- register chat and comms
	RANB:RegisterChatCommand("nb", "ChatCommands")
end

function RANB:ChatCommands(input)
	-- process chat comms
	local input = strlower(input or "")
	local isRaidLeader = UnitIsGroupLeader("player")

	if isRaidLeader and not isShow then
		isShow = true
		RANB:Print(L["Asking who need the next boss."])

		local frameF = AceGUI:Create("Frame")
		frameF:SetTitle(L["Rise Above Need Boss"])
		frameF:SetWidth(490)
		frameF:SetHeight(410)
		frameF:SetStatusText(L["People who need the next boss"])
		frameF:SetCallback("OnClose", fechandoFrame1)
		frameF:SetLayout("Flow")
		
		local g11 = AceGUI:Create("InlineGroup")
		g11:SetTitle(L["People in raid:"])
		g11:SetWidth(220)
		g11:SetHeight(150)
		g11:SetLayout("Fill")
		g11:SetAutoAdjustHeight(true)
		g11i = AceGUI:Create("SimpleGroup")
		g11i:SetFullWidth(true)
		g11i:SetFullHeight(true)
		g11i:SetLayout("Flow")
		g11:AddChild(g11i)
		
		local g21 = AceGUI:Create("InlineGroup")
		g21:SetWidth(220)
		g21:SetHeight(150)
		g21:SetTitle(L["People not in raid:"])
		g21:SetLayout("Fill")
		g21:SetAutoAdjustHeight(true)
		g21i = AceGUI:Create("SimpleGroup")
		g21i:SetFullWidth(true)
		g21i:SetFullHeight(true)
		g21i:SetLayout("Flow")
		g21:AddChild(g21i)
		
		local g12 = AceGUI:Create("InlineGroup")
		g12:SetWidth(220)
		g12:SetHeight(150)
		g12:SetTitle(L["Want to go out:"])
		g12:SetLayout("Fill")
		g12:SetAutoAdjustHeight(true)
		g12i = AceGUI:Create("SimpleGroup")
		g12i:SetFullWidth(true)
		g12i:SetFullHeight(true)
		g12i:SetLayout("Flow")
		g12:AddChild(g12i)
		
		local g22 = AceGUI:Create("InlineGroup")
		g22:SetWidth(220)
		g22:SetHeight(150)
		g22:SetTitle(L["Need to go in:"])
		g22:SetLayout("Fill")
		g22:SetAutoAdjustHeight(true)
		g22i = AceGUI:Create("SimpleGroup")
		g22i:SetFullWidth(true)
		g22i:SetFullHeight(true)
		g22i:SetLayout("Flow")
		g22:AddChild(g22i)

		frameF:AddChild(g11)
		frameF:AddChild(g21)
		frameF:AddChild(g12)
		frameF:AddChild(g22)
		
		montaArrayRaid()
		distribuiRaiders()
		
		RANB:RegisterEvent("CHAT_MSG_RAID", mensagemRaid)
		RANB:RegisterEvent("CHAT_MSG_RAID_LEADER", mensagemRaid)
		--RANB:RegisterEvent("CHAT_MSG_PARTY", mensagemRaid)

		SendChatMessage(L["Who need the next boss type '1', who wants to stay out type '2'."], "PARTY")
	elseif isRaidLeader and isShow then
		SendChatMessage(L["Who need the next boss type '1', who wants to stay out type '2'."], "PARTY")
	else
		RANB:Print(L["Only the Raid Leader can ask."])
	end
end

function RANB:AskCommand(prefix, message, distribution, sender)
	RANB:Print(message)
end

function fechandoFrame1(widget)
	RANB:UnregisterEvent("CHAT_MSG_RAID")
	RANB:UnregisterEvent("CHAT_MSG_RAID_LEADER")
	--RANB:UnregisterEvent("CHAT_MSG_PARTY")
	isShow = false
	AceGUI:Release(widget)
end

function mensagemRaid(event, text, nameRealm, ...)
	local s = string.sub(text, 1, 1) 
	if s == "1" or s == "2" then
		name = nameRealm:gsub("%-.+", "")
		local plr = AceGUI:Create("Label")
		plr:SetWidth(60)
		plr:SetText(name)
		if s == "1" then
			mudaPlayerGrupo(name, 1)
		elseif s == "2" then
			mudaPlayerGrupo(name, 2)
		end
		distribuiRaiders()
	end
end

function montaArrayRaid()
	local opt = 11
	RAIDERS = {}
	for i = 1, GetNumGroupMembers() do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML  = GetRaidRosterInfo(i)
		local plr = AceGUI:Create("Label")
		if subgroup <= 4 then
			opt = 11
		elseif subgroup > 4 then
			opt = 21
		end
		RAIDERS[i] = {name = name, color = RAID_CLASS_COLORS[fileName], option = opt}
	end
end

function distribuiRaiders()
	g11i:ReleaseChildren()
	g21i:ReleaseChildren()
	g12i:ReleaseChildren()
	g22i:ReleaseChildren()
	for i = 1, table.getn(RAIDERS) do
		local plr = AceGUI:Create("Label")
		plr:SetText(RAIDERS[i].name)
		plr:SetWidth(60)
		plr:SetColor(RAIDERS[i].color.r, RAIDERS[i].color.g, RAIDERS[i].color.b)
		if RAIDERS[i].option == 11 then
			g11i:AddChild(plr)
		elseif RAIDERS[i].option == 21 then
			g21i:AddChild(plr)
		elseif RAIDERS[i].option == 12 then
			g12i:AddChild(plr)
		elseif RAIDERS[i].option == 22 then
			g22i:AddChild(plr)
		end
	end
end

function mudaPlayerGrupo(name, option)
	for i = 1, table.getn(RAIDERS) do
		if RAIDERS[i].name == name then
			if option == 1 then               --1. quer entrar
				if RAIDERS[i].option == 21 then  
					RAIDERS[i].option = 22
				elseif RAIDERS[i].option == 12 then
					RAIDERS[i].option = 11
				end
			elseif option == 2 then           -- 2. quer sair
				if RAIDERS[i].option == 11 then
					RAIDERS[i].option = 12
				elseif RAIDERS[i].option == 22 then
					RAIDERS[i].option = 21
				end
			end
		end
	end
end

-- 11 dentro (pode ir pro 12 se apertar 2)
-- 21 fora (pode ir pro 22 se apertar 1)
-- 12 quer sair (pode ir pro 11 se apertar 1)
-- 22 quer entrar (pode ir pro 21 se apertar 2)
